#include <stdio.h>
#include <stdlib.h>
#include <string.h>


struct Zelle {
	int ID;
	char BasicBefehle[1024];
	char HexCode[1024];
	};


struct keyword{
	char  Befehle[1024];
	int ID;
	};

struct out{
	char HexCode[1024];
	int ID;
	};


struct Zelle *XML2Struct[1024];
struct keyword *TXT2Struct[1024];
struct out *Output[1024];
int r,t,out1,jie; 	//r--how many keywords, t--how many words in Soucedatei, out1--how many words should be output, jie=t
int i,j,l,wo;	 //--i:Laenger der Sourcedatei---j:Laenger der XML----l:Laenger der Outputdatei---wo:Laenger der einzelen Woerter von Sourcedatei
//int stelle;
int st=0;//counts how many numbers appear after the keywords like "MOVE"
int m=0; // m counts how many times the keywords like "MOVE", "DIR" etc. appear.
int dez,y,bi,cou;  // dez-- dezimalzahl, bi--verschieden m?gliche Zahlendarstellung hinter den Schlsselw?rtern
char hex[1024]={'\0'};
char bin[1024]={'\0'};//binaer Zahl
//int binaer;
int la; // count how many numbers should appear after the keywords.
int bpo=0;	//bpo=1--byteout, bpo=2--PWM, bpo=3--out
int anfz;   //G6A--Anfangszahl=0, G6B--Anfangszahl=6,..., G8B--Anfangszahl=8

void WriteTextBlockFrom(FILE* fp, char* buf)
{
	char* beg;
	char* end;
	beg = strstr(buf, ">");
	end = strstr(buf, "</");
	if( beg < end && beg != NULL && end != NULL)
	{
		fwrite(beg+1, end - beg - 1, 1, fp );
		fprintf(fp,"\r\n");
	}
}


void FindInXML(const char* strInputXML, const char* strBewegung, const char* strDestFile)
{
	FILE *fp1;
    	FILE *fp2;

   	char buf[1024];
	int pos = 0;
	int nLen = 0;
	int pTextBegin=0;
	int nSearchLen = strlen(strBewegung);

	if( (fp1=fopen(strInputXML,"r"))==NULL )
   	 {
        printf("cannot open this file!");
        exit(0);
   	 }
    	if( (fp2=fopen(strDestFile,"w"))==NULL )
    	{
        printf("cannot create this file!");
        fclose(fp1);
        exit(0);
    	}

    while(!feof(fp1))		//wenn pointer am Ende, feof =0, else =1; 
    {
    	memset(buf, 0, 1024);		//buf =0
       fgets(buf, 1024, fp1);		//von fp1 bis zu buf
		pos=0;
		nLen = strlen(buf);
		while( buf[pos] == ' ' && pos < nLen)
		{
			pos++;
		}
		if( pos < nLen )
		{
			if( pos + 10 < nLen )
			{     /*memcmp() vergleicht zwei Speicherbereiche ber eine whlbare Gre. 
				Der Rckgabewert ist 0, wenn die Speicherbereiche gleich sind.
				*/
				if( memcmp("<Befehler>", buf + pos, 10 ) == 0 )
				{
					if( pos + 10 + nSearchLen + 11 <= nLen
						&& memcmp(buf + pos + 10, strBewegung, nSearchLen ) == 0
						&& memcmp(buf + pos + 10 + nSearchLen, "</Befehler>", 11) == 0 )
					{
						//found the Bewegung
						while(!feof(fp1))
						{
							fgets(buf, 1024, fp1);
							if( strstr(buf, "</Table>") != NULL )
							{
								fclose(fp1);
								fclose(fp2);
								return;
							}

                     else if((strstr(buf, "<Nr>")) != NULL)
							{
                                                   // kein output
							}



                    else if( strstr(buf, "</") !=NULL )
							{
								
								WriteTextBlockFrom(fp2, buf);
							}
						}
					}
				}
			}
		}
    }
    fclose(fp1);
    fclose(fp2);
}


void Sourcelesen(const char* strInputTXT)
{


int N=0;

FILE *fp1;
char buf[1024];
char *token;
	

if( (fp1=fopen(strInputTXT,"r"))==NULL )
    {
        printf("cannot open this file!\n");
        exit(0);
    }

	while(!feof(fp1))
	{
		memset(buf, 0, 1024);
		fgets(buf, 1024, fp1);

     	 	printf("buf=%s\n",buf);
     	 	token = strtok(buf," /,\n");
     	 	while (token != NULL)
		{
	   		TXT2Struct[N]=(struct keyword*)malloc(sizeof(struct keyword));	
          		printf("The token is: %s\n",token);
			strcpy(TXT2Struct[N]->Befehle,token);
          		printf("The ID is: %d\n", N);
	   		TXT2Struct[N]->ID=N;
         		token = strtok(NULL," /,\n");
			N++;
		}	
	}
		 N--;   
		t=N;  
	jie=t+1;
	printf("jie=%d\n",jie);
	for(N;N>=0;N--)
	{
		printf("the keyword %d is: %s\n", TXT2Struct[N]->ID, TXT2Struct[N]->Befehle);
	}
}

void XMLtoTXT(const char* strInputXML)
{
	int Nr=0;
	
	static const char filename[] = "test.txt";
	FILE *file = fopen ( filename, "r" );
	
	if ( file != NULL )
	{
 		char line [256]; /* oder die Max. Zeile-Lang */
		while ( fgets ( line, sizeof line, file ) != NULL ) /* lesen eine Zeile */
		{
			XML2Struct[Nr]=(struct Zelle*)malloc(sizeof(struct Zelle));								
			XML2Struct[Nr]->ID=Nr;                                                      
			strcpy(XML2Struct[Nr]->BasicBefehle,line);							
			fgets ( line, sizeof line, file );									
			strcpy(XML2Struct[Nr]->HexCode,line);
			Nr++;
		}
	fclose ( file );
	}
	else
	{
		perror ( filename ); /* wenn es einen Error da gibt? */
	}

	Nr--;
	r=Nr;

	printf("%d\n",XML2Struct[Nr]->ID);
								
	for (Nr; Nr>=0; Nr--)
	{
		printf("Nr %d BasicBefehle ist: %s\n",Nr, XML2Struct[Nr]->BasicBefehle );
		printf("Nr %d HexCode ist: %s\n", Nr,XML2Struct[Nr]->HexCode);
	}
}


void speed(int a)
{
	if(i==t) strcpy(TXT2Struct[a]->Befehle, "Error1");
	else
	{
	if(atoi(TXT2Struct[a+1]->Befehle)==0&&(TXT2Struct[a+1]->Befehle)!="0")
	{
		strcpy(TXT2Struct[a+1]->Befehle, "Error");
	}
	else
	{
		if(atoi(TXT2Struct[a+1]->Befehle)>15)//Zahl darf nicht groesser als 15?
		{
			strcpy(TXT2Struct[a+1]->Befehle, "Error1");  
		}
	}
}
}

void GYRODIR(int a)
{
	if(i==t) strcpy(TXT2Struct[a]->Befehle, "Error1");
	else
	{
	if(atoi(TXT2Struct[a+1]->Befehle)==0&&(TXT2Struct[a+1]->Befehle)!="0")
	{
		strcpy(TXT2Struct[a+1]->Befehle, "Error");
	}
	else
	{
		if(atoi(TXT2Struct[a+1]->Befehle)>1)//Zahl darf nicht groesser als 2?
		{
			strcpy(TXT2Struct[a+1]->Befehle, "Error1");  
		}
	}
	}
}

void GYROSENSE(int a)
{
	if(i==t) strcpy(TXT2Struct[a]->Befehle, "Error1");
	else
	{
	if(atoi(TXT2Struct[a+1]->Befehle)==0&&(TXT2Struct[a+1]->Befehle)!="0")
	{
		strcpy(TXT2Struct[a+1]->Befehle, "Error");
	}
	else
	{
		if(atoi(TXT2Struct[a+1]->Befehle)>255)//Zahl darf nicht groesser als 255?
		{
			strcpy(TXT2Struct[a+1]->Befehle, "Error1");  
		}
	}
	}
}

void byteout(int a)
{
	if(i==t) strcpy(TXT2Struct[a]->Befehle, "Error1");
	else
	{
		if(atoi(TXT2Struct[a+1]->Befehle)==0&&(TXT2Struct[a+1]->Befehle)!="0")
		{
			strcpy(TXT2Struct[a+1]->Befehle, "Error1");
		}
		else if(atoi(TXT2Struct[a+2]->Befehle)==0&&(TXT2Struct[a+2]->Befehle)!="0")
		{
			strcpy(TXT2Struct[a+2]->Befehle, "Error1");
		}
		else
		{
			if((bpo==1)&&(atoi(TXT2Struct[a+2]->Befehle)>255))//Zahl darf nicht groesser als 255?
			{
				strcpy(TXT2Struct[a+2]->Befehle, "Error1");  
			}
			else if((bpo==2)&&(atoi(TXT2Struct[a+1]->Befehle)>5))//Zahl darf nicht groesser als 255?
			{
				strcpy(TXT2Struct[a+1]->Befehle, "Error1");  
			}
			else if((bpo==3)&&(atoi(TXT2Struct[a+2]->Befehle)>1))
			{
				strcpy(TXT2Struct[a+2]->Befehle, "Error1"); 
			}
		}
	}
}

void fpwm(int a)
{
	if(i==t) strcpy(TXT2Struct[a]->Befehle, "Error1");
	else
	{
		if(atoi(TXT2Struct[a+1]->Befehle)==0&&(TXT2Struct[a+1]->Befehle)!="0")
		{
			strcpy(TXT2Struct[a+1]->Befehle, "Error1");
		}
		else if(atoi(TXT2Struct[a+2]->Befehle)==0&&(TXT2Struct[a+2]->Befehle)!="0")
		{
			strcpy(TXT2Struct[a+2]->Befehle, "Error1");
		}
		else if(atoi(TXT2Struct[a+3]->Befehle)==0&&(TXT2Struct[a+3]->Befehle)!="0")
		{
			strcpy(TXT2Struct[a+3]->Befehle, "Error1");
		}
		else
		{
			if(atoi(TXT2Struct[a+1]->Befehle)>2)//Zahl darf nicht groesser als 2?
			{
				strcpy(TXT2Struct[a+1]->Befehle, "Error1");  
			}
			else if((atoi(TXT2Struct[a+2]->Befehle)<1)||(atoi(TXT2Struct[a+1]->Befehle)>5))//Zahl darf nicht groesser als 2?
			{
				strcpy(TXT2Struct[a+2]->Befehle, "Error1");  
			}
			else if(atoi(TXT2Struct[a+3]->Befehle)>255)//Zahl darf nicht groesser als 255?
			{
				strcpy(TXT2Struct[a+3]->Befehle, "Error1");  
			}
		}
	}
}

void move(int b)
{
	
	if((TXT2Struct[b+1]->Befehle[0]=='G')&&(TXT2Struct[b+1]->Befehle[1]=='6')) la=6;
	
	else if((TXT2Struct[b+1]->Befehle[0]=='G')&&(TXT2Struct[b+1]->Befehle[1]=='8')) la=8;
	
	else if((TXT2Struct[b+1]->Befehle[0]=='G')&&(TXT2Struct[b+1]->Befehle[1]=='1')&&(TXT2Struct[b+1]->Befehle[2]=='2')) la=12;
	
	else if((TXT2Struct[b+1]->Befehle[0]=='G')&&(TXT2Struct[b+1]->Befehle[1]=='1')&&(TXT2Struct[b+1]->Befehle[2]=='6')) la=16;
	
	else if((TXT2Struct[b+1]->Befehle[0]=='G')&&(TXT2Struct[b+1]->Befehle[1]=='2')&&(TXT2Struct[b+1]->Befehle[2]=='4')) la=24;
	
	else if((TXT2Struct[b+1]->Befehle[0]=='G')&&(TXT2Struct[b+1]->Befehle[1]=='3')&&(TXT2Struct[b+1]->Befehle[2]=='2')) la=32;
	
}

void aimotor(int b)
{
	
	if((TXT2Struct[b+1]->Befehle[0]=='G')&&(TXT2Struct[b+1]->Befehle[1]=='6')) 
	{
		la=6;
		if(TXT2Struct[i+1]->Befehle[2]=='A') anfz=0;
		else if(TXT2Struct[i+1]->Befehle[2]=='B') anfz=6;
		else if(TXT2Struct[i+1]->Befehle[2]=='C') anfz=12;
		else if(TXT2Struct[i+1]->Befehle[2]=='D') anfz=18;
	}
	else if((TXT2Struct[b+1]->Befehle[0]=='G')&&(TXT2Struct[b+1]->Befehle[1]=='8')) 
	{
		la=8;
		if(TXT2Struct[i+1]->Befehle[2]=='A') anfz=0;
		else if(TXT2Struct[i+1]->Befehle[2]=='B') anfz=8;
		else if(TXT2Struct[i+1]->Befehle[2]=='C') anfz=16;
	}
	else if((TXT2Struct[b+1]->Befehle[0]=='G')&&(TXT2Struct[b+1]->Befehle[1]=='1')&&(TXT2Struct[b+1]->Befehle[2]=='2')) 
	{
		la=12;
		if(TXT2Struct[i+1]->Befehle[2]=='A') anfz=0;
		else if(TXT2Struct[i+1]->Befehle[2]=='B') anfz=12;
	}
	else if((TXT2Struct[b+1]->Befehle[0]=='G')&&(TXT2Struct[b+1]->Befehle[1]=='2')&&(TXT2Struct[b+1]->Befehle[2]=='4')) 
	{
		la=24;
		anfz=0;
	}
}


void dth(int dt)
{
	char he[1024];	
	int z,w,u;
	int mod;

	printf("dez=%d\n",dez);
	if((dez/16)>0)
	{
		for(z=0;dez!=0;z++)
		{	
			mod=dez%16;	
			if(mod>9) he[z]='A'+(mod-10);
			else he[z]='0'+mod;
			dez=dez/16;				
		}
	}
	else
	{
		mod=dez%16;
		if(mod>9) he[0]='A'+(mod-10);
		else he[0]='0'+mod;
		he[1]='0';
		z=2;
	}		
	w=z;
	u=z-1;
						
	for(y=0;y<w;y++)
	{
		for(u;u>=0;u--)
		{	
			//printf("u = %d\n",u);
			hex[y]=he[u];					
			//printf("y ist %d hex[]=%c\n",y,hex[y]);
			y++;
		}
	}
}

void compare(const char* strInputXML,const char* strInputTXT)
{
	XMLtoTXT("test.txt");
	Sourcelesen("Source.txt");
//-----------int r,t,m darf nicht mehr benutzen---------------------------------
	int c,g,fan,fan1;
	//int i,j,l,wo;       //--i:Laenger der Sourcedatei---j:Laenger der XML----l:Laenger der Outputdatei---wo:Laenger der einzelen Woerter von Sourcedatei
	int kor=0;
	int lang,lang1;
	int counter=0;
	int ai=0;  //ai=1--AIMOTOR; ai=2--AIMOTOROFF; ai=3--MOTOT; ai=4--MOTOROFF
	int en;  //en=1-> datei am Ende 
	int em; // is sourcedata leer?
	int many; //how many words in the Outputdata
	int yid=0;
	int ag=0; //wenn es g6x\g8x hinter Aimotor steht, ist ag=1,sonst ag=0.

	char hexc[1024];	
	int z1,w1,u1;
	int mod1;

	if(jie==0) em=1;
	else em=0;

	if(em==1)
	{
		for(l=0;l<=jie;l++)
		{
			for(int head=0; head<=24;head++)
			{
				Output[l]=(struct out*)malloc(sizeof(struct out));
				strcpy(Output[l]->HexCode, "00");
				l++;
			}
			for(int head=25; head<=144;head++)
			{
				Output[l]=(struct out*)malloc(sizeof(struct out));
				strcpy(Output[l]->HexCode, "20");
				l++;
			}
			for(int head=145; head<=146;head++)
			{
				Output[l]=(struct out*)malloc(sizeof(struct out));
				strcpy(Output[l]->HexCode, "00");
				l++;
			}
			for(int tail=0; tail<=2;tail++)
			{
				Output[l]=(struct out*)malloc(sizeof(struct out));
				strcpy(Output[l]->HexCode, "C4");
				Output[l+1]=(struct out*)malloc(sizeof(struct out));
				strcpy(Output[l+1]->HexCode, "10");
				Output[l+2]=(struct out*)malloc(sizeof(struct out));
				strcpy(Output[l+2]->HexCode, "00");		
			}
		}
		out1=l+1;
	}
     else if(em==0)
{
//----------wechseln den kleine Buchstabe zum grosse Buchstabe-------
	for(i=0;i<=t;i++)
	{
		for(wo=0;wo<=strlen(TXT2Struct[i]->Befehle);wo++)
		{
				if(TXT2Struct[i]->Befehle[wo]>='a'&&TXT2Struct[i]->Befehle[wo]<='z')
				TXT2Struct[i]->Befehle[wo]=TXT2Struct[i]->Befehle[wo]-32;
		}
	}
//--------------------------------------------------------------------------------------
	
	for(l=0;l<=t;l++)
	{
			for(int head=0; head<=24;head++)
			{
				Output[l]=(struct out*)malloc(sizeof(struct out));
				strcpy(Output[l]->HexCode, "00");
				l++;
			}
			for(int head=25; head<=144;head++)
			{
				Output[l]=(struct out*)malloc(sizeof(struct out));
				strcpy(Output[l]->HexCode, "20");
				l++;
			}
			for(int head=145; head<=146;head++)
			{
				Output[l]=(struct out*)malloc(sizeof(struct out));
				strcpy(Output[l]->HexCode, "00");
				l++;
			}
				
		for(i=0; i<=t;i++)
		{
			if(i==t) en=1;
			else en=0;
		
			for(j=0;j<=r;j++)
			{
				c=strncmp(TXT2Struct[i]->Befehle,XML2Struct[j]->BasicBefehle,strlen(XML2Struct[j]->BasicBefehle)-2);
				fan=strncmp(TXT2Struct[i]->Befehle,XML2Struct[j]->BasicBefehle,strlen(TXT2Struct[i]->Befehle));
				lang=strlen(TXT2Struct[i]->Befehle);
				lang1=strlen(XML2Struct[j]->BasicBefehle)-2;
					
				Output[l]=(struct out*)malloc(sizeof(struct out));	
				Output[l]->ID=l;

				if(c==0&&fan==0)
				{	
					la=0;
					ai=0;
					bi=0;

					printf(XML2Struct[j]->HexCode);
					strcpy(Output[l]->HexCode,XML2Struct[j]->HexCode);
					printf("Die Nr. %d Hexcode ist %s\n",l,Output[l]->HexCode);
//=======if found "SPEED" ============================================
					if (strncmp("SPEED",TXT2Struct[i]->Befehle,5)==0)
					{
						st=0;
						yid=0;
						bi=0;
						la=0;
						speed(i);
						la=1;
						Output[l+1]=(struct out*)malloc(sizeof(struct out));	
						strcpy(Output[l+1]->HexCode, "12");
						l++;
					}
//=======if found "TEMPO" ============================================
			 		if (strncmp("TEMPO",TXT2Struct[i]->Befehle,5)==0)
					{
						st=0;
						yid=0;
						bi=0;
						la=0;
						speed(i);
						la=1;
						Output[l+1]=(struct out*)malloc(sizeof(struct out));	
						strcpy(Output[l+1]->HexCode, "12");
						l++;
					}
//=======if found "MOVE" =============================================					
				 	if(strncmp("MOVE",TXT2Struct[i]->Befehle,4)==0)
					{ 
						st=0;
						yid=1;
						bi=0;
						ag=0;
						move(i);
					}
//=======if found "POS" =============================================					
				 	if(strncmp("POS",TXT2Struct[i]->Befehle,3)==0)
					{ 
						st=0;
						yid=1;
						bi=0;
						ag=0;
						move(i);
					}
//=======if found "INIT" =============================================					
				 	if(strncmp("INIT",TXT2Struct[i]->Befehle,4)==0)
					{ 
						st=0;
						yid=1;
						bi=0;
						ag=0;
						move(i);
					}
//=======if found "GETMOTORSET" =============================================					
				 	if(strncmp("GETMOTORSET",TXT2Struct[i]->Befehle,11)==0)
					{ 
						st=0;
						yid=1;
						bi=2;
						ag=0;
						move(i);
					}
//=======wenn "MOTOR"============================================
					if((strncmp("MOTOR",TXT2Struct[i]->Befehle,5)==0)&&strlen(TXT2Struct[i]->Befehle)==5)
					{
						st=0;
						bi=0;
						ai=3;
						if(TXT2Struct[i+1]->Befehle[0]=='G') 
						{		
							aimotor(i);
							ag=1;
						}
						else if(TXT2Struct[i+1]->Befehle[0]=='A') anfz=0;	
					}
//=======wenn "MOTOROFF"============================================
					if(strncmp("MOTOROFF",TXT2Struct[i]->Befehle,8)==0)
					{
						st=0;
						bi=0;
						ai=4;
						if(TXT2Struct[i+1]->Befehle[0]=='G') 
						{		
							aimotor(i);
							ag=1;
						}
						else if(TXT2Struct[i+1]->Befehle[0]=='A') anfz=0;	
					}
//=======wenn "AIMOTOR"============================================
					if((strncmp("AIMOTOR",TXT2Struct[i]->Befehle,7)==0)&&strlen(TXT2Struct[i]->Befehle)==7)
					{
						st=0;
						bi=0;
						ai=1;
						if(TXT2Struct[i+1]->Befehle[0]=='G') 
						{		
							aimotor(i);
							ag=1;
						}
					}
//=======wenn "AIMOTOROFF"============================================
					if(strncmp("AIMOTOROFF",TXT2Struct[i]->Befehle,10)==0)
					{
						st=0;
						bi=0;
						ai=2;
						if(TXT2Struct[i+1]->Befehle[0]=='G') 
						{		
							aimotor(i);
							ag=1;
						}
					}
//=======wenn"DIR"==================================================
 					if(strncmp("DIR",TXT2Struct[i]->Befehle,3)==0)
					{ 
						st=0;
						bi=1;
						yid=1;
						ag=0;
						if(TXT2Struct[i+1]->Befehle[0]=='G') move(i);
						else 
						{
							strcpy(Output[l]->HexCode, "EC");
								la=6;
						}
					}
//=======wenn"MOVE24"=================================================	
		             	if(strncmp("MOVE24", TXT2Struct[i]->Befehle,6)==0)
					{
						st=0;
						bi=0;
						la=24;	

						Output[l+1]=(struct out*)malloc(sizeof(struct out));
						strcpy(Output[l+1]->HexCode, "00");
						l++;
						Output[l+1]=(struct out*)malloc(sizeof(struct out));
						strcpy(Output[l+1]->HexCode, "18");
						l++;
					}
//=======wenn"GYRODIR"=================================================	
		             	if(strncmp("GYRODIR", TXT2Struct[i]->Befehle,7)==0)	
					{
						st=0;
						yid=0;
						bi=0;
						la=0;
						GYRODIR(i);
						la=1;
					}
//=======wenn"GYROSENSE"=================================================	
					if(strncmp("GYROSENSE", TXT2Struct[i]->Befehle,9)==0)	
					{
						st=0;
						yid=0;
						bi=0;
						la=0;
						GYROSENSE(i);
						la=1;
					}	
//=======wenn"LOCATE"=================================================	
					if(strncmp("LOCATE", TXT2Struct[i]->Befehle,6)==0)	
					{
						st=0;
						yid=0;
						bi=0;
						la=2;
						byteout(i);
					}
//=======wenn"BYTEOUT"=================================================	
					if(strncmp("BYTEOUT", TXT2Struct[i]->Befehle,7)==0)	
					{
						st=0;
						yid=0;
						bi=0;
						la=2;
						bpo=1;
						byteout(i);
					}
//=======wenn"PWM"=================================================	
					if(strncmp("PWM", TXT2Struct[i]->Befehle,3)==0)	
					{
						st=0;
						yid=0;
						bi=0;
						la=2;
						bpo=2;
						byteout(i);	
					}
//=======wenn"OUT"=================================================	
					if(strncmp("OUT", TXT2Struct[i]->Befehle,3)==0)	
					{
						st=0;
						yid=0;
						bi=0;
						la=2;
						bpo=3;
						byteout(i);	
					}
//=======wenn"FPWM"=================================================	
					if(strncmp("FPWM", TXT2Struct[i]->Befehle,4)==0)	
					{
						st=0;
						yid=0;
						bi=0;
						la=3;
						fpwm(i);
					}						
					l++;
				}

				else
				{ 		
//=======decimal-to-hexadecimal converter  ===========================================
					if(((TXT2Struct[i]->Befehle[0]>='0')&&(TXT2Struct[i]->Befehle[0]<='9'))&&(ai==0))
					{	 
						dez=atoi(TXT2Struct[i]->Befehle);
						int ende;
						printf("dez ist %d\n",dez);

						if(st==0)
						{			
							ende=0;
							dth(i);
							st++;	
						}
						else if((en==0)&&((TXT2Struct[i+1]->Befehle[0]>='0')&&(TXT2Struct[i+1]->Befehle[0]<='9'))&&(ai==0))
						{ 
							dth(i);
							st++;
							ende=0;
						}
						else if((en==1)||((en==0)&&(atoi(TXT2Struct[i+1]->Befehle)==0&&(TXT2Struct[i+1]->Befehle)!="0"))) 
						{
							st++;
							dth(i);
							ende=1;								
						}
						
						printf("st=%d\n",st);
						printf("la=%d\n",la);
						//cou=st+1;                                                                                                                                        
						//printf("cou=%d\n",cou);

						if((la==0)||((la==1)&&(st>1))||((la==2)&&(st>2))||((la==3)&&(st>3))||((la==6)&&(st>=7))||((la==8)&&(st>8))||((la==12)&&(st>12))||((la==16)&&(st>16))||((la==24)&&(st>24))||((la==32)&&(st>32)))
						{	
							strcpy(Output[l]->HexCode, "Fehler bei Zahl");
						}	
						else if(((la==6)&&(st<=6)) || ((la==8)&&(st<=8)) || ((la==12)&&(st<=12)) || ((la==16)&&(st<=16))||((la==24)&&(st<=24))||((la==32)&&(st<=32)))
						{		
							if(bi==0)
							{
								if(ende==0)
								{
									if((atoi(TXT2Struct[i]->Befehle)>190)||(atoi(TXT2Struct[i]->Befehle)<10)) strcpy(Output[l]->HexCode, "Fehler beim Zahl");
									else strncpy(Output[l]->HexCode,hex,y-1);
								}
								else if(ende==1)
								{
									if((atoi(TXT2Struct[i]->Befehle)>190)||(atoi(TXT2Struct[i]->Befehle)<10)) strcpy(Output[l]->HexCode, "Fehler beim Zahl");
									else strncpy(Output[l]->HexCode,hex,y-1);

									if(st!=la)
									{	
										int shu;
										for(l;shu<(la-st);l++)
										{
											Output[l+1]=(struct out*)malloc(sizeof(struct out));
											strcpy(Output[l+1]->HexCode, "00");
											shu++;
										}
									}
								}
							}
							else if(bi==1)
							{	
								if(atoi(TXT2Struct[i]->Befehle)>=2) strcpy(Output[l]->HexCode, "Fehler beim Zahl");
								else
								{
									if(ende==1)
									{										
										switch(st)
										{
											case 6 : 
												dez=(atoi(TXT2Struct[i]->Befehle)*32)+(atoi(TXT2Struct[i-1]->Befehle)*16)+(atoi(TXT2Struct[i-2]->Befehle)*8)+(atoi(TXT2Struct[i-3]->Befehle)*4)+(atoi(TXT2Struct[i-4]->Befehle)*2)+(atoi(TXT2Struct[i-5]->Befehle));
												break;
											case 5:
												dez=32+(atoi(TXT2Struct[i]->Befehle)*16)+(atoi(TXT2Struct[i-1]->Befehle)*8)+(atoi(TXT2Struct[i-2]->Befehle)*4)+(atoi(TXT2Struct[i-3]->Befehle)*2)+(atoi(TXT2Struct[i-4]->Befehle));
												break;
											case 4:
												dez=48+(atoi(TXT2Struct[i]->Befehle)*8)+(atoi(TXT2Struct[i-1]->Befehle)*4)+(atoi(TXT2Struct[i-2]->Befehle)*2)+(atoi(TXT2Struct[i-3]->Befehle));
												break;
											case 3:
												dez=56+(atoi(TXT2Struct[i]->Befehle)*4)+(atoi(TXT2Struct[i-1]->Befehle)*2)+(atoi(TXT2Struct[i-2]->Befehle));
												break;
											case 2:
												dez=60+(atoi(TXT2Struct[i]->Befehle)*2)+(atoi(TXT2Struct[i-1]->Befehle));
												break;
											case 1:
												dez=62+atoi(TXT2Struct[i]->Befehle);
												break;
											case 0:
												dez=63;
												break;
										}
										dth(i);
										strncpy(Output[l]->HexCode, hex,2);	
									}
									else if(ende==0) l--;
								}
							}
						else if(bi==2)
							{
								if(ende==0)
								{
									if(atoi(TXT2Struct[i]->Befehle)>1) strcpy(Output[l]->HexCode, "Fehler beim Zahl");
									else strncpy(Output[l]->HexCode,hex,y-1);
								}
								else if(ende==1)
								{
									if(atoi(TXT2Struct[i]->Befehle)>1) strcpy(Output[l]->HexCode, "Fehler beim Zahl");
									else strncpy(Output[l]->HexCode,hex,y-1);

									if(st!=la)
									{	
										int shu;
										for(l;shu<(la-st);l++)
										{
											Output[l+1]=(struct out*)malloc(sizeof(struct out));
											strcpy(Output[l+1]->HexCode, "00");
											shu++;
										}
									}
								}
							}	
						}
						else strncpy(Output[l]->HexCode, hex,y-1);

						l++;
						break;
//------------------------------------------------------------------------------------------------------
					}
					else if(TXT2Struct[i]->Befehle[0]=='G'&&strlen(TXT2Struct[i]->Befehle)==3)
					{ 
						st=0;
						printf("yid=%d\n",yid);
						if(ag==0)
						{
							if(yid==1)
							{
								if(TXT2Struct[i]->Befehle[1]=='6')
								{
									if(TXT2Struct[i]->Befehle[2]=='A') strcpy(Output[l]->HexCode, "00");
									else if(TXT2Struct[i]->Befehle[2]=='B') strcpy(Output[l]->HexCode, "06");
									else if(TXT2Struct[i]->Befehle[2]=='C') strcpy(Output[l]->HexCode, "0C");
									else if(TXT2Struct[i]->Befehle[2]=='D') strcpy(Output[l]->HexCode, "12");

									Output[l+1]=(struct out*)malloc(sizeof(struct out));
									strcpy(Output[l+1]->HexCode, "06");
									l++;
								}
								else if(TXT2Struct[i]->Befehle[1]=='8')
								{
									if(TXT2Struct[i]->Befehle[2]=='A') strcpy(Output[l]->HexCode, "00");
									else if(TXT2Struct[i]->Befehle[2]=='B') strcpy(Output[l]->HexCode, "08");
									else if(TXT2Struct[i]->Befehle[2]=='C') strcpy(Output[l]->HexCode, "10");
						
									Output[l+1]=(struct out*)malloc(sizeof(struct out));
									strcpy(Output[l+1]->HexCode, "08");
									l++;
								}
								else if(TXT2Struct[i]->Befehle[1]=='1')
								{
									if(TXT2Struct[i]->Befehle[2]=='2') strcpy(Output[l]->HexCode, "00");
						
									Output[l+1]=(struct out*)malloc(sizeof(struct out));
									strcpy(Output[l+1]->HexCode, "0C");
									l++;
								}
								else if(TXT2Struct[i]->Befehle[1]=='1')
								{
									if(TXT2Struct[i]->Befehle[2]=='6') strcpy(Output[l]->HexCode, "00");
								
									Output[l+1]=(struct out*)malloc(sizeof(struct out));
									strcpy(Output[l+1]->HexCode, "10");
									l++;
								}
								else if(TXT2Struct[i]->Befehle[1]=='2')
								{
									if(TXT2Struct[i]->Befehle[2]=='4') strcpy(Output[l]->HexCode, "00");
							
									Output[l+1]=(struct out*)malloc(sizeof(struct out));
									strcpy(Output[l+1]->HexCode, "18");
									l++;
								}
									yid=0;
							}
							else if(yid==0)
							{
								strcpy(Output[l]->HexCode, "grammatikfehle");	
							}
							l++;
							break;
					  	}
						else if(ag==1)
						{
							int ji=0;
							//if((la==6)&&(anfz==0))
							if((anfz==0)&&(ai<3))
							{
								for(l;ji<2;l=l+2)
								{
									Output[l-1]=(struct out*)malloc(sizeof(struct out));
									if(ai==1) strcpy(Output[l-1]->HexCode, "B7");
									else if(ai==2) strcpy(Output[l-1]->HexCode, "B8");
									else if(ai==3) strcpy(Output[l-1]->HexCode, "DA");
									else if(ai==4) strcpy(Output[l-1]->HexCode, "DB");
									Output[l]=(struct out*)malloc(sizeof(struct out));
									if(ji==0) strcpy(Output[l]->HexCode, "10");
									else strcpy(Output[l]->HexCode, "11");
									ji++;
								}
								//l=l-1;	
								for(l;ji<la;l=l+3)
								{
									Output[l-1]=(struct out*)malloc(sizeof(struct out));
									if(ai==1) strcpy(Output[l-1]->HexCode, "B7");
									else if(ai==2) strcpy(Output[l-1]->HexCode, "B8");
									else if(ai==3) strcpy(Output[l-1]->HexCode, "DA");
									else if(ai==4) strcpy(Output[l-1]->HexCode, "DB");
									Output[l]=(struct out*)malloc(sizeof(struct out));
									strcpy(Output[l]->HexCode, "12");	
									Output[l+1]=(struct out*)malloc(sizeof(struct out));
									int durchzahl;
									durchzahl=anfz+ji;
									

								if((durchzahl/16)>0)
								{
									for(z1=0;durchzahl!=0;z1++)
									{	
										mod1=durchzahl%16;	
										if(mod1>9) hexc[z1]='A'+(mod1-10);
										else hexc[z1]='0'+mod1;
										durchzahl=durchzahl/16;				
									}
								}
								else
								{
									mod1=durchzahl%16;
									if(mod1>9) hexc[0]='A'+(mod1-10);
									else hexc[0]='0'+mod1;
									hexc[1]='0';
									z1=2;
								}		
									w1=z1;
									u1=z1-1;
						
								for(y=0;y<w1;y++)
								{
									for(u1;u1>=0;u1--)
									{	
										hex[y]=hexc[u1];					
										y++;
									}
								}
									strncpy(Output[l+1]->HexCode, hex,y-1);
									ji++;
								}
								l=l-1;
								break;
							}
							//else if((la==6)&&(anfz!=0))
							else if(anfz!=0)
							{
								for(l;ji<la;l=l+3)
								{
									Output[l-1]=(struct out*)malloc(sizeof(struct out));
									if(ai==1) strcpy(Output[l-1]->HexCode, "B7");
									else if(ai==2) strcpy(Output[l-1]->HexCode, "B8");
									else if(ai==3) strcpy(Output[l-1]->HexCode, "DA");
									else if(ai==4) strcpy(Output[l-1]->HexCode, "DB");
									Output[l]=(struct out*)malloc(sizeof(struct out));
									strcpy(Output[l]->HexCode, "12");	
									Output[l+1]=(struct out*)malloc(sizeof(struct out));
									int durchzahl;
									durchzahl=anfz+ji;
									//char hexc[1024];	
									//int z1,w1,u1;
									//int mod1;

								if((durchzahl/16)>0)
								{
									for(z1=0;durchzahl!=0;z1++)
									{	
										mod1=durchzahl%16;	
										if(mod1>9) hexc[z1]='A'+(mod1-10);
										else hexc[z1]='0'+mod1;
										durchzahl=durchzahl/16;				
									}
								}
								else
								{
									mod1=durchzahl%16;
									if(mod1>9) hexc[0]='A'+(mod1-10);
									else hexc[0]='0'+mod1;
									hexc[1]='0';
									z1=2;
								}		
									w1=z1;
									u1=z1-1;
						
								for(y=0;y<w1;y++)
								{
									for(u1;u1>=0;u1--)
									{	
										hex[y]=hexc[u1];					
										y++;
									}
								}
									strncpy(Output[l+1]->HexCode, hex,y-1);
									ji++;
								}
								l=l-1;
								break;	
							}
							if((anfz==0)&&(ai>2))
							{
								for(l;ji<2;l=l+2)
								{
									Output[l-1]=(struct out*)malloc(sizeof(struct out));
									if(ai==3) strcpy(Output[l-1]->HexCode, "DA");
									else if(ai==4) strcpy(Output[l-1]->HexCode, "DB");
									Output[l]=(struct out*)malloc(sizeof(struct out));
									if(ji==0) strcpy(Output[l]->HexCode, "10");
									else strcpy(Output[l]->HexCode, "11");
									ji++;
								}
								//l=l-1;	
								for(l;ji<la;l=l+3)
								{
									Output[l-1]=(struct out*)malloc(sizeof(struct out));
									if(ai==3) strcpy(Output[l-1]->HexCode, "DA");
									else if(ai==4) strcpy(Output[l-1]->HexCode, "DB");
									Output[l]=(struct out*)malloc(sizeof(struct out));
									strcpy(Output[l]->HexCode, "12");	
									Output[l+1]=(struct out*)malloc(sizeof(struct out));
									int durchzahl;
									durchzahl=anfz+ji;
									

								if((durchzahl/16)>0)
								{
									for(z1=0;durchzahl!=0;z1++)
									{	
										mod1=durchzahl%16;	
										if(mod1>9) hexc[z1]='A'+(mod1-10);
										else hexc[z1]='0'+mod1;
										durchzahl=durchzahl/16;				
									}
								}
								else
								{
									mod1=durchzahl%16;
									if(mod1>9) hexc[0]='A'+(mod1-10);
									else hexc[0]='0'+mod1;
									hexc[1]='0';
									z1=2;
								}		
									w1=z1;
									u1=z1-1;
						
								for(y=0;y<w1;y++)
								{
									for(u1;u1>=0;u1--)
									{	
										hex[y]=hexc[u1];					
										y++;
									}
								}
									strncpy(Output[l+1]->HexCode, hex,y-1);
									ji++;
								}
								l=l-1;
								break;
							}
						}
						
					}
					else if(strncmp(TXT2Struct[i]->Befehle,"SETON",5)==0)
					{   
						st=0;
						la=0;
						if((strncmp(TXT2Struct[i-1]->Befehle,"PTP",3)==0)||(strncmp(TXT2Struct[i-1]->Befehle,"HIGHSPEED",9)==0)) strcpy(Output[l]->HexCode, "01");
						else if(strncmp(TXT2Struct[i-1]->Befehle,"AIMOTOR",7)==0)
						{	
							strcpy(Output[l-1]->HexCode, "B6");
							strcpy(Output[l]->HexCode, "03");
						}
							
						l++;
						break;
					}
					else if(strncmp(TXT2Struct[i]->Befehle,"SETOFF",6)==0)
					{
						la=0;
						if(strncmp(TXT2Struct[i-1]->Befehle,"AIMOTOR",7)==0)
						{	
							strcpy(Output[l-1]->HexCode, "B6");
							strcpy(Output[l]->HexCode, "02");
						}
						else if(strncmp(TXT2Struct[i-1]->Befehle,"HIGHSPEED",9)==0) strcpy(Output[l]->HexCode, "00");

						l++;
						break;
					}
					else if((strncmp(TXT2Struct[i]->Befehle,"0",1)==0)&&(ai!=0))
					{    
						la=0;
						if((strncmp(TXT2Struct[i-1]->Befehle,"AIMOTOR",7)==0)&&(ai==1))
						{	
							strcpy(Output[l-1]->HexCode, "B7");
							strcpy(Output[l]->HexCode, "10");
						}
						else if(strncmp(TXT2Struct[i-1]->Befehle,"AIMOTOROFF",10)==0)
						{	
							strcpy(Output[l-1]->HexCode, "B8");
							strcpy(Output[l]->HexCode, "10");
						}
						else if(strncmp(TXT2Struct[i-1]->Befehle,"MOTOROFF",8)==0)
						{	
							strcpy(Output[l-1]->HexCode, "DA");
							strcpy(Output[l]->HexCode, "10");
						}
						else if((strncmp(TXT2Struct[i-1]->Befehle,"MOTOR",5)==0)&&(ai==3)) strcpy(Output[l]->HexCode, "10");
						else strcpy(Output[l]->HexCode, "0");
							
						ai=0;
						l++;
						break;
					}
					else if(strncmp(TXT2Struct[i]->Befehle,"ALLON",5)==0)
					{
						la=0;
						if(strncmp(TXT2Struct[i-1]->Befehle,"PTP",3)==0) //strcpy(Output[l]->HexCode, "06");
						{	
							strcpy(Output[l-1]->HexCode, "B6");
							strcpy(Output[l]->HexCode, "06");
						}
						else if((strncmp(TXT2Struct[i-1]->Befehle,"MOTOR",5)==0)&&(ai==3))
						{
							int ji=0;
								for(l;ji<2;l=l+2)
								{
									Output[l-1]=(struct out*)malloc(sizeof(struct out));
									strcpy(Output[l-1]->HexCode, "DA");
									Output[l]=(struct out*)malloc(sizeof(struct out));
									if(ji==0) strcpy(Output[l]->HexCode, "10");
									else strcpy(Output[l]->HexCode, "11");
									ji++;
								}
								//l=l-1;	
								for(l;ji<24;l=l+3)
								{
									Output[l-1]=(struct out*)malloc(sizeof(struct out));
									strcpy(Output[l-1]->HexCode, "DA");
									Output[l]=(struct out*)malloc(sizeof(struct out));
									strcpy(Output[l]->HexCode, "12");	
									Output[l+1]=(struct out*)malloc(sizeof(struct out));
									int durchzahl;
									durchzahl=anfz+ji;
									

								if((durchzahl/16)>0)
								{
									for(z1=0;durchzahl!=0;z1++)
									{	
										mod1=durchzahl%16;	
										if(mod1>9) hexc[z1]='A'+(mod1-10);
										else hexc[z1]='0'+mod1;
										durchzahl=durchzahl/16;				
									}
								}
								else
								{
									mod1=durchzahl%16;
									if(mod1>9) hexc[0]='A'+(mod1-10);
									else hexc[0]='0'+mod1;
									hexc[1]='0';
									z1=2;
								}		
									w1=z1;
									u1=z1-1;
						
								for(y=0;y<w1;y++)
								{
									for(u1;u1>=0;u1--)
									{	
										hex[y]=hexc[u1];					
										y++;
									}
								}
									strncpy(Output[l+1]->HexCode, hex,y-1);
									ji++;
								}
								l=l-1;
								break;
						}

						l++;
						break;
					}
					else if(strncmp(TXT2Struct[i]->Befehle,"ALLOFF",6)==0)
					{
						la=0;
						if(strncmp(TXT2Struct[i-1]->Befehle,"PTP",3)==0) //strcpy(Output[l]->HexCode, "05");
						{	
							strcpy(Output[l-1]->HexCode, "B6");
							strcpy(Output[l]->HexCode, "05");
						}
						else if(strncmp(TXT2Struct[i-1]->Befehle,"MOTOROFF",8)==0)
						{
							int ji=0;
								for(l;ji<2;l=l+2)
								{
									Output[l-1]=(struct out*)malloc(sizeof(struct out));
									strcpy(Output[l-1]->HexCode, "DB");
									Output[l]=(struct out*)malloc(sizeof(struct out));
									if(ji==0) strcpy(Output[l]->HexCode, "10");
									else strcpy(Output[l]->HexCode, "11");
									ji++;
								}
								//l=l-1;	
								for(l;ji<24;l=l+3)
								{
									Output[l-1]=(struct out*)malloc(sizeof(struct out));
									strcpy(Output[l-1]->HexCode, "DB");
									Output[l]=(struct out*)malloc(sizeof(struct out));
									strcpy(Output[l]->HexCode, "12");	
									Output[l+1]=(struct out*)malloc(sizeof(struct out));
									int durchzahl;
									durchzahl=anfz+ji;
									

								if((durchzahl/16)>0)
								{
									for(z1=0;durchzahl!=0;z1++)
									{	
										mod1=durchzahl%16;	
										if(mod1>9) hexc[z1]='A'+(mod1-10);
										else hexc[z1]='0'+mod1;
										durchzahl=durchzahl/16;				
									}
								}
								else
								{
									mod1=durchzahl%16;
									if(mod1>9) hexc[0]='A'+(mod1-10);
									else hexc[0]='0'+mod1;
									hexc[1]='0';
									z1=2;
								}		
									w1=z1;
									u1=z1-1;
						
								for(y=0;y<w1;y++)
								{
									for(u1;u1>=0;u1--)
									{	
										hex[y]=hexc[u1];					
										y++;
									}
								}
									strncpy(Output[l+1]->HexCode, hex,y-1);
									ji++;
								}
								l=l-1;
								break;
							}
						l++;
						break;
					}
					else if(strncmp("Error1",TXT2Struct[i]->Befehle,6)==0)
					{
						strcpy(Output[l]->HexCode, "Fehler beim Zahl");

						l++;
						break;
					}
					else
					{
						for(counter=0;counter<=r;counter++)
						{	
							g=strncmp(TXT2Struct[i]->Befehle,XML2Struct[counter]->BasicBefehle,strlen(XML2Struct[counter]->BasicBefehle)-2);
							fan1=strncmp(TXT2Struct[i]->Befehle,XML2Struct[counter]->BasicBefehle,strlen(TXT2Struct[i]->Befehle));		

							if(g!=0&&fan1!=0&&counter==r) kor++;
							else if(g==0&&fan1==0&&counter<=r)
							{
								kor=0;
								break;
							}
									
						}

						printf("kor=%d\n",kor);

						if(kor==35)
						{
							strcpy(Output[l]->HexCode, "Buchstabefehle");
							kor=0;
							l++;
							continue;
						}

						continue;
						
					}	
				}
			}
			printf("i=%d\nen=%d\n",i,en);
		}
	if(en==1) //break;	
		{
			many=l-131;//-10+16  --- 10: head; ---16 : dez from 10 in hex
			dez=many;
				if(many!=16)
				{
					char hexz[1024];	
					int z,w,u;
					int mod;

					if((many/16)>0)
					{
						for(z=0;many!=0;z++)
						{	
							mod=many%16;	
							if(mod>9) hexz[z]='A'+(mod-10);
							else hexz[z]='0'+mod;
							many=many/16;				
						}
					}
					else
					{
						mod=many%16;
						if(mod>9) hexz[0]='A'+(mod-10);
						else hexz[0]='0'+mod;
						hexz[1]='0';
						z=2;
					}		
					w=z;
					u=z-1;
						
					for(y=0;y<w;y++)
					{
						for(u;u>=0;u--)
						{	
							hex[y]=hexz[u];					
							y++;
						}
					}
				}
			for(int tail=0; tail<=2;tail++)
			{
				Output[l]=(struct out*)malloc(sizeof(struct out));
				strcpy(Output[l]->HexCode, "C4");
				Output[l+1]=(struct out*)malloc(sizeof(struct out));
				strncpy(Output[l+1]->HexCode, hex,y-1);
				Output[l+2]=(struct out*)malloc(sizeof(struct out));
				strcpy(Output[l+2]->HexCode, "00");
				
			}
		}
	}
		out1=l+1;
}

		//out1=l+1;
		printf("out1=%d\n",out1);
		printf("l=%d\n",l);
		printf("em=%d\n",em);

	for(l=out1; l>=0;l--)
	{
		printf("Die Nr. %d HexCode ist %s\n",l,Output[l]->HexCode);
	}
}



int main(void)
{
	FindInXML( "test_xml.xml", "Befehler im Hexcode", "test.txt");
	compare("test.txt","Source.txt");
	char line[256];
	printf("Output[0]->HexCode = %s\n",Output[0]->HexCode);
	FILE  *fp;
	fp = fopen("output.txt", "w");
	int q;
	q=out1;
	for(out1=0;out1<=q;out1++)
	{
		printf("Output[%d]->HexCode = %s\n",out1,Output[out1]->HexCode);
		strncpy(line,Output[out1]->HexCode,strlen(Output[out1]->HexCode));
		printf(line);
		fwrite(line, 1, 2,fp);
		fprintf(fp,"\0");
	}

	fclose(fp);
	printf("ENDE\n");

  	 return 0;
}
